searchData={"content_type":"text/markdown","items":[{"doc":"harness the boilerplate!","ref":"Harness.html","title":"Harness","type":"module"},{"doc":"","ref":"Harness.html#ignore_patterns/0","title":"Harness.ignore_patterns/0","type":"function"},{"doc":"","ref":"Harness.html#version/0","title":"Harness.version/0","type":"function"},{"doc":"A local project's harness configuration","ref":"Harness.Manifest.html","title":"Harness.Manifest","type":"module"},{"doc":"gets the path of the archive itself","ref":"Harness.Manifest.html#archive_path/0","title":"Harness.Manifest.archive_path/0","type":"function"},{"doc":"Loads the manifest onto the project stack and loads dependencies\n\nBy clearing and pushing a fake project onto the `Mix.ProjectStack`, we can\nutilize large parts of the Mix codebase without much hacking or rewriting.\n\nThis function clears the existing stack and pushes a configuration onto it.\nMost of the configuration follows the defaults, but the dependencies are\nread from the harness manifest (`harness.exs`) and the dependency versions\nare locked to `harness.lock`.","ref":"Harness.Manifest.html#load/1","title":"Harness.Manifest.load/1","type":"function"},{"doc":"reads the manifest file from the path","ref":"Harness.Manifest.html#read/1","title":"Harness.Manifest.read/1","type":"function"},{"doc":"Verifies that the generated files in .harness match the configuration of\nthe harness.exs","ref":"Harness.Manifest.html#verify/1","title":"Harness.Manifest.verify/1","type":"function"},{"doc":"A behaviour for defining harness package modules.\n\nHarness packages should add a `pkg.exs` to their root directory which\ndescribes a single module which implements this behaviour.","ref":"Harness.Pkg.html","title":"Harness.Pkg","type":"behaviour"},{"doc":"A function to transform incoming opts (in keyword format) into a package's\nstruct (`t:t/0`).\n\nThe simplest `cast/1` is like so:\n\n    def cast(opts), do: struct(__MODULE__, opts)","ref":"Harness.Pkg.html#c:cast/1","title":"Harness.Pkg.cast/1","type":"callback"},{"doc":"A list of links to create from the .harness directory to project root.\n\nThe link can be a string path which will be created as a symlink or the\nlink can be a tuple with the path and an atom declaring the type of link as\n`:sym` or `:hard`.","ref":"Harness.Pkg.html#c:links/1","title":"Harness.Pkg.links/1","type":"callback"},{"doc":"","ref":"Harness.Pkg.html#otp_app/1","title":"Harness.Pkg.otp_app/1","type":"function"},{"doc":"","ref":"Harness.Pkg.html#path/1","title":"Harness.Pkg.path/1","type":"function"},{"doc":"A package module's struct","ref":"Harness.Pkg.html#t:t/0","title":"Harness.Pkg.t/0","type":"type"},{"doc":"Helper functions for renders\n\nThese functions are accessible inside templates.","ref":"Harness.Renderer.Helpers.html","title":"Harness.Renderer.Helpers","type":"module"},{"doc":"Either inspects an item or interpolates it.\n\nIf the item is a binary, it is interpolated. Else, it is inspected with\n`Kernel.inspect/2` and then interpolated.","ref":"Harness.Renderer.Helpers.html#inspect_or_interpolate/1","title":"Harness.Renderer.Helpers.inspect_or_interpolate/1","type":"function"},{"doc":"Converts a string or atom into PascalCase\n\nMakes use of the `Macro.camelize/1` function underneath.","ref":"Harness.Renderer.Helpers.html#pascal/1","title":"Harness.Renderer.Helpers.pascal/1","type":"function"},{"doc":"Renders things as a tree\n\nSee the original implementation in Mix\n[here](https://github.com/elixir-lang/elixir/blob/v1.10/lib/mix/lib/mix/utils.ex).\n\nThe original implementation has an optimization for dependency trees which\nprevents showing the same dependency tree twice. That's great for printing\nsmall dependency trees, but for file trees, we want to see the entire tree\nevery time, even if a file or directory name is present many times.\n\nThe changes to the original implementation are shown as comments below:","ref":"Harness.Tree.html","title":"Harness.Tree","type":"module"},{"doc":"Prints the given tree according to the callback.\nThe callback will be invoked for each node and it\nmust return a `{printed, children}` tuple.","ref":"Harness.Tree.html#print_tree/3","title":"Harness.Tree.print_tree/3","type":"function"},{"doc":"Renders harness packages into the current directory\n\nConfiguration of which files to generate and link is according to the current\ndirectory's harness manifest (`harness.exs`).","ref":"Mix.Tasks.Harness.html","title":"mix harness","type":"task"},{"doc":"* `--no-compile` - skips the compilation of harness packages\n  * `--no-deps-check` - skips a check for out of date dependencies","ref":"Mix.Tasks.Harness.html#module-command-line-options","title":"Command line options - mix harness","type":"task"},{"doc":"Checks that the `.harness` directory is up-to-date with the manifest","ref":"Mix.Tasks.Harness.Check.html","title":"mix harness.check","type":"task"},{"doc":"Removes links, files, and directories generated by harness","ref":"Mix.Tasks.Harness.Clean.html","title":"mix harness.clean","type":"task"},{"doc":"Compiles harness package dependencies\n\nLoads the current harness manifest, checks to ensure dependencies have been\nfeteched, and then compiles harness package files.","ref":"Mix.Tasks.Harness.Compile.html","title":"mix harness.compile","type":"task"},{"doc":"Fetches harness dependencies according to a harness.exs\n\nHarness dependencies follow the same format and rules as mix dependencies:\nyou may use (public/private) hex, git, or local paths, and dependencies may\nbe semantically versioned when fetched via hex.","ref":"Mix.Tasks.Harness.Get.html","title":"mix harness.get","type":"task"},{"doc":"Checks, compiles, and loads all harness packages","ref":"Mix.Tasks.Harness.Loadpaths.html","title":"mix harness.loadpaths","type":"task"},{"doc":"* `--no-compile` - skips the compilation of harness packages\n  * `--no-deps-check` - skips a check for out of date dependencies","ref":"Mix.Tasks.Harness.Loadpaths.html#module-command-line-options","title":"Command line options - mix harness.loadpaths","type":"task"},{"doc":"Updates harness dependencies according to a harness.exs\n\nThis task mimics `mix deps.update` (and uses it for the implementation).\nAny options are passed directly to the invocation of `mix deps.update`","ref":"Mix.Tasks.Harness.Update.html","title":"mix harness.update","type":"task"},{"doc":"# Harness\n\n![Actions CI](https://github.com/NFIBrokerage/harness/workflows/Actions%20CI/badge.svg)\n\nA command line tool for harnessing Elixir boilerplate.\n\nSee the [hex guides](https://hexdocs.pm/harness/welcome.html#content)\nfor detail documentation.\n\nLooking for an example package? [`harness_dotfiles`][harness-dotfiles]\nshould serve as a minimal example to get you going.","ref":"readme.html","title":"Harness","type":"extras"},{"doc":"Interested in developing harness? Currently it's in a tight spot because it\ndoesn't have any test cases. Your best bet for blessing harness is to build\nand install harness archives locally and use the local installation to harness\npackages like `harness_micro_controller`.\n\n```\nmix archive.uninstall harness --force\nMIX_ENV=prod mix archive.build\nmix archive.install harness-0.0.0.ez --force\n```","ref":"readme.html#development","title":"Development - Harness","type":"extras"},{"doc":"Harness is installed as an archive:\n\n```\nmix archive.install hex harness --force\n```\n\nHarness depends on elixir 1.9+. If you use `asdf`:\n\n```\nasdf install erlang 22.3\nasdf install elixir 1.10.4-otp-22\nasdf global erlang 22.3\nasdf global elixir 1.10.4-otp-22\nmix archive.install hex harness --force\n```\n\n[harness-dotfiles]: https://github.com/NFIBrokerage/harness_dotfiles","ref":"readme.html#installation","title":"Installation - Harness","type":"extras"},{"doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a\nChangelog](https://keepachangelog.com/en/1.0.0/), and this project adheres to\n[Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-8-3-2024-09-25","title":"0.8.3 - 2024-09-25 - Changelog","type":"extras"},{"doc":"- Makes sure all harness archive tasks are loaded and available to use","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-8-2-2024-03-18","title":"0.8.2 - 2024-03-18 - Changelog","type":"extras"},{"doc":"- Updated `actions/checkout@` from `v3` to `v4` in GH actions\n- Updated `actions/cache@` from `v3` to `v4` in GH actions\n- Updated `NFIBrokerage/create-release@` from `v3` to `v4` in GH actions","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-8-1-2023-08-24","title":"0.8.1 - 2023-08-24 - Changelog","type":"extras"},{"doc":"- Updated `actions/checkout@` from `v1` to `v3` in GH actions\n- Updated `actions/cache@` from `v1` to `v3` in GH actions\n- Updated `NFIBrokerage/create-release@` from `v2` to `v3` in GH actions\n- Change `release_name` to `name` field in `NFIBrokerage/create-release@v3`\n  action in GH actions\n- Fixed credo warnings","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-8-0-2023-08-09","title":"0.8.0 - 2023-08-09 - Changelog","type":"extras"},{"doc":"- This version fixes warnings and errors encountered when using `harness` with\n  Elixir 1.15\n    - added harness archive ebin path to VM path list because Elixir 1.15\n      prunes code paths before compiling\n    - `EEx.eval_string/3` is now used instead of `EEx.eval_file/3` when\n      rendering templates with import of `Harness.Renderer.Helpers` functions\n      being appended to every template binary because passing `:functions` in\n      options is deprecated since Elixir 1.13","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-7-3-2023-04-05","title":"0.7.3 - 2023-04-05 - Changelog","type":"extras"},{"doc":"- Updated `hackney` from 1.16 to 1.18.1\n- Pinned ubuntu runner to `ubuntu-20.04` in workflows because of OTP 22.3","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-7-2-2021-11-29","title":"0.7.2 - 2021-11-29 - Changelog","type":"extras"},{"doc":"- Fixed compatibility with older elixir versions","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-7-1-2021-11-29","title":"0.7.1 - 2021-11-29 - Changelog","type":"extras"},{"doc":"- Eliminated raise when harness packages were not yet compiled when calling `mix harness`","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-7-0-2021-11-26","title":"0.7.0 - 2021-11-26 - Changelog","type":"extras"},{"doc":"- Added a `mix harness.loadpaths` Mix Task that mirrors `mix deps.loadpaths`\n    - this task loads, compiles, and checks harness packages to ensure that\n      they are up to date and can be installed\n- Added `--no-compile` and `--no-deps-check` flags to `mix harness` task","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-6-2-2021-03-17","title":"0.6.2 - 2021-03-17 - Changelog","type":"extras"},{"doc":"- Trimmed strings in the `inspect_or_interpolate/1` helper\n    - this prevents formatting failures when a template does not expect a\n      newline and a manifest declares a value with triple-quotes","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-6-1-2021-03-08","title":"0.6.1 - 2021-03-08 - Changelog","type":"extras"},{"doc":"- Replaced usages of `Keyword.pop!/2` with `Keyword.pop/3`\n    - This fixes compilation on Elixir 1.9","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-6-0-2021-03-03","title":"0.6.0 - 2021-03-03 - Changelog","type":"extras"},{"doc":"- Added a `mix harness.check` task which checks that the harnessed files are\n  up to date","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-5-0-2021-02-24","title":"0.5.0 - 2021-02-24 - Changelog","type":"extras"},{"doc":"- Added support for hard linking to files in `.harness`\n- Updated the `Harness.Pkg` behaviour to declare links with a tuple that\n  includes the link type `:sym` or `:hard`\n    - e.g. `{\"mix.exs\", :sym}` or `{\".github/workflows/ci.yml\", :hard}`","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-4-0-2021-02-19","title":"0.4.0 - 2021-02-19 - Changelog","type":"extras"},{"doc":"- Added a `config :harness, :version` key which checks the version of harness\n  and ensures that a manifest is only rendered if the harness version matches","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-3-0-2021-02-17","title":"0.3.0 - 2021-02-17 - Changelog","type":"extras"},{"doc":"- Added a `:skip_files` key to the configuration of a manifest, allowing one\n  to provide a list of regex which will be checked against while sourcing files.\n  Any files found to match any of the regex will be excluded from generation.\n    - this allows a service author to 'take the reins' for that file","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-9-2020-11-02","title":"0.2.9 - 2020-11-02 - Changelog","type":"extras"},{"doc":"- Fixed a broken link to the Getting Started guide from the About guide","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-8-2020-10-15","title":"0.2.8 - 2020-10-15 - Changelog","type":"extras"},{"doc":"- Added a `mix harness.update` task that mimics `mix deps.update`","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-7-2020-10-15","title":"0.2.7 - 2020-10-15 - Changelog","type":"extras"},{"doc":"- Misc. documentation fixes including:\n    - a broken link to the Getting Started guide\n    - addition of GitHub and Changelog links to hex page\n    - default documentation page is set to the README","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-6-2020-10-12","title":"0.2.6 - 2020-10-12 - Changelog","type":"extras"},{"doc":"- Fixed a bug present when running `mix harness.compile` in Elixir 1.11+","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-5-2020-10-06","title":"0.2.5 - 2020-10-06 - Changelog","type":"extras"},{"doc":"- Harness now explicitly depends on `:eex` as an extra_application\n    - this resolves compilation warnings on elixir 1.11+","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-4-2020-10-05","title":"0.2.4 - 2020-10-05 - Changelog","type":"extras"},{"doc":"- Generated files are now formatted to a column width of 80","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-3-2020-09-22","title":"0.2.3 - 2020-09-22 - Changelog","type":"extras"},{"doc":"- Harness is now published to public hex","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-2-2020-08-30","title":"0.2.2 - 2020-08-30 - Changelog","type":"extras"},{"doc":"- `Kernel` functions are now imported for templates by default.\n    - e.g. `==/2` or `inspect/2`","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-1-2020-08-27","title":"0.2.1 - 2020-08-27 - Changelog","type":"extras"},{"doc":"- Fixed a bug where multiple copies of the same directory would show if the\n  directory contained multiple files to be linked","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-0-2020-08-26","title":"0.2.0 - 2020-08-26 - Changelog","type":"extras"},{"doc":"- Manifests are now written with the [Config\n  API](https://hexdocs.pm/elixir/1.10.4/Config.html#content)\n    - therefore the manifest version has increased to v2.0.0\n- As a result of the above, harness now requires at least Elixir 1.9 for\n  compatibility","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-1-2-2020-08-25","title":"0.1.2 - 2020-08-25 - Changelog","type":"extras"},{"doc":"- A function to interpolate or inspect items into a template","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-1-1-2020-08-25","title":"0.1.1 - 2020-08-25 - Changelog","type":"extras"},{"doc":"- Elixir LS files are now ignored from generation","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-1-0-2020-08-25","title":"0.1.0 - 2020-08-25 - Changelog","type":"extras"},{"doc":"- Improvements to display. First stable-ish release","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-0-1-2020-08-24","title":"0.0.1 - 2020-08-24 - Changelog","type":"extras"},{"doc":"- Vim swap files are now ignored from template directories\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- The harness project is reloaded after `mix harness.compile` when running `mix\n  harness`\n    - this fixes an issue where otp app atoms could not be determined on clean\n      harness runs, as in CI\n\n#","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"- The `Harness.Cache` module has been removed\n    - now harness caches packages by downloading them to the `deps/` directory\n    - this behaviour mimics `mix`","ref":"changelog.html#removed","title":"Removed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-0-0-2020-08-24","title":"0.0.0 - 2020-08-24 - Changelog","type":"extras"},{"doc":"- Initial dependency management and generation abilities","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#initial-commit-2020-08-19","title":"initial commit - 2020-08-19 - Changelog","type":"extras"},{"doc":"- This project was generated by Gaas","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"# Welcome\n\nWelcome to the harness documentation. As in the notorious Captain Underpants\nnovels, you may choose your own adventure:\n\n- [What is harness?](guides/About.md)\n- [Let's Get Started!](guides/GettingStarted.md)","ref":"welcome.html","title":"Welcome","type":"extras"},{"doc":"# About Harness\n\nThere are many ways to describe harness. Harness:\n\n- simplifies writing tiny isolated services by dynamically generating\n  unecessary boilerplate files\n- makes it easy to version your _practices_\n- lets you make a library out of anything!\n\nBut overall, harness is really about one thing: service chassis (plural).","ref":"about.html","title":"About Harness","type":"extras"},{"doc":"What's a _service chassis_? A [service\nchassis](https://microservices.io/patterns/microservice-chassis.html) is a\ncollection of tooling that sets the bar for what makes one of your services one\nof your services. For example, in [our](https://github.com/NFIBrokerage) Elixir\nshoppe, we have a service chassis that includes:\n\n- [`asdf`](https://github.com/asdf-vm/asdf) for language version management\n- [`excoveralls`](https://hex.pm/packages/excoveralls) for testing coverage\n- [`credo`](https://hex.pm/packages/credo) for linting\n- [`distillery`](https://hex.pm/packages/distillery) for release building\n- [Appsignal](https://appsignal.com/) for error reporting and metrics\n\nAnd more (I can't give _all_ our secrets away, can I? ;).\n\nFor these, we need a `.tool-versions`, a `.credo.exs`, a `coveralls.json`, a\n`rel/config.exs` and `rel/.formatter.exs`, and configuration and\nin-application-space code changes for Appsignal. Seems like a lot? Imagine all\nthe other configuration I'm not even mentioning like private tooling and\n`Dockerfile`s!\n\nIf you have one service running your business, this isn't too big of a deal.\nOne times the aforementioned number of configuration files isn't too bad. It's\nmanageable. But what about if you have 10 services? 50? 100?","ref":"about.html#services-chassis","title":"Services Chassis - About Harness","type":"extras"},{"doc":"If your organization employs a micro-service architecture and you've developed\nmore than 20 services, you have probably used a static code generation tool.\nThey're great! Plug in X Y and Z like the repository name, application name,\nand secret key-base, and you can have a fresh phoenix app up and running in no\ntime!\n\nIn our organization, we have a centralized static code generation tool called\nGaaS (Git as a Service). A LiveView front-end plus a DSL for easy templates\nequals a very nice user experience for generating new code.  [GitHub\ntemplates](https://github.blog/2019-06-06-generate-new-repositories-with-repository-templates/)\nare a free and ready-to-use alternative.\n[`mix_generator`](https://github.com/pragdave/mix_generator) is another good\ntool for Elixir projects in specific.\n\nWe used static code generation tools alone for a long time with great effect.","ref":"about.html#enter-static-code-generation-tooling","title":"Enter static code generation tooling - About Harness","type":"extras"},{"doc":"So what's the big deal then if static code generation tools work so well? The\nproblem lies in how your organization adopts and alters _practices_ over time.\n\nConsider this scenario: in an app, you add a new way of doing something that\nmay be useful for all apps, like using the (shameless plug)\n[`bless`](https://hex.pm/packages/bless) library for running the gambit on\nyour testing/linting suite. It's a great practice, so let's add it to all our\nservices! To do so, we first modify our `mix.exs` generator(s) to depend on\nand/or configure `bless`. Then we can either run the updated generator(s) over\nexisting codebases or manually change those services. With 10 or so services\neither way is fine, but over 20 or 50 or 100 services? Even small changes start\nto hurt.","ref":"about.html#where-static-code-generation-tools-fall-short","title":"Where static code generation tools fall short - About Harness","type":"extras"},{"doc":"Harness takes a different approach. Harness is more like a package manager\n(think the mix+hex relationship or `npm`/`yarn` or `cargo` crates). Imagine if\nyou checked in all the `node_modules/` stuff from `npm`? Gross. Like red wine\nin a white carpet. Finding any specific file in that mess? Impossible. Changing\nthat directory across hundreds of repositories? Herculean.\n\nInstead, the harness approach is to describe everything a static code\ngeneration tool does with a _manifest_, and then never check in the generated\nfiles.","ref":"about.html#enter-harness","title":"Enter Harness - About Harness","type":"extras"},{"doc":"Manifests describe a _plan_. They don't detail the specifics like which\nversions of dependencies we'll use exactly (think a `mix.lock`) but rather a\nset of rules or guidelines to use to form a project.\n\nFor harness, this is the `harness.exs`.\n\nEnough of the theory though, let's [Get Started!](guides/GettingStarted.md)","ref":"about.html#manifests","title":"Manifests - About Harness","type":"extras"},{"doc":"# Getting Started\n\nLet's get going!\n\nFirst, you need a recent version of elixir (`~> 1.9`). Consider trying\n[`asdf`](https://github.com/asdf-vm/asdf) as a language version management\ntool. Now install harness:\n\n```shell\nmix archive.install hex harness --force\n```\n\nRun `mix help harness` to verify installation.","ref":"gettingstarted.html","title":"Getting Started","type":"extras"},{"doc":"There are a few components that make up a harnessed repository.\n\nLike a regular mix project, a harness project typically has:\n\n- `lib/` containing your application-space code\n- `test/` unit tests for application-space code in `lib/`\n- `config/` configuration\n\nBut none of these are requirements for harness. For a harness project, all you\nreally need is a [harness manifest](guides/Manifests.md).\n\nOnce you have a manifest, a run of `mix harness.get` in that directory will\nfetch harness packages (think dependencies), and then a run of `mix harness`\nwill render the project.","ref":"gettingstarted.html#making-a-harness-project","title":"Making a harness project - Getting Started","type":"extras"},{"doc":"Say that we have a tiny service in our stack called a micro (µ) controller.\nIt's a single phoenix controller (in reality, just a plug) that handles a\nrequest and performs some action. Setting up a whole service chassis for a\nservice this small might be annoying, but with a well-groomed harness micro\ncontroller package, it can be quite simple.\n\nSay you have a git repo for a µ controller that looks like this:\n\n```shell\n$ tree -a -I '.git'\n.\n├── .github\n│   ├── settings.yml\n│   ├── stale.yml\n│   └── workflows\n│       └── ci.yml\n├── .gitignore\n├── README.md\n├── config\n│   ├── config.exs\n│   ├── dev.exs\n│   ├── prod.exs\n│   └── test.exs\n├── harness.exs\n├── lib\n│   ├── access_token_controller.ex\n│   ├── access_token_fetcher.ex\n│   └── access_token_verifier.ex\n├── mix.lock\n└── test\n    ├── access_token_controller_test.exs\n    └── support\n        └── mocks.ex\n\n6 directories, 16 files\n```\n\nIn a directory with a harness-file (`harness.exs`), a run of `mix harness` will\ngenerate a `.harness/` directory containing generated boilerplate, with the\nnecessary symlinking and path adjusting to make the project run like a normal\nphoenix project.\n\nFor example, the above repository would expand to something like:\n\n```shell\n$ mix harness\n$ tree -a -I '.git|_build|deps|.elixir_ls|cover'\n.\n├── .credo.exs -> .harness/.credo.exs\n├── .dockerignore -> .harness/.dockerignore\n├── .formatter.exs -> .harness/.formatter.exs\n├── .github\n│   ├── settings.yml\n│   ├── stale.yml\n│   └── workflows\n│       └── ci.yml\n├── .gitignore\n├── .harness\n│   ├── .credo.exs\n│   ├── .dockerignore\n│   ├── .formatter.exs\n│   ├── .tool-versions\n│   ├── Dockerfile\n│   ├── config\n│   │   ├── config.exs\n│   │   ├── dev.exs\n│   │   ├── prod.exs\n│   │   └── test.exs\n│   ├── coveralls.json\n│   ├── lib\n│   │   ├── authentication_service_access_token_controller\n│   │   │   └── application.ex\n│   │   ├── authentication_service_access_token_controller_web\n│   │   │   ├── channels\n│   │   │   ├── controllers\n│   │   │   │   └── version_controller.ex\n│   │   │   ├── endpoint.ex\n│   │   │   ├── gettext.ex\n│   │   │   ├── router.ex\n│   │   │   └── views\n│   │   │       ├── error_helpers.ex\n│   │   │       └── error_view.ex\n│   │   └── authentication_service_access_token_controller_web.ex\n│   ├── mix.exs\n│   ├── rel\n│   │   └── config.exs\n│   └── test\n│       ├── authentication_service_access_token_controller_web\n│       │   ├── controllers\n│       │   │   └── version_controller_test.exs\n│       │   ├── live\n│       │   └── views\n│       │       └── error_view_test.exs\n│       ├── support\n│       │   ├── conn_case.ex\n│       │   └── mock_release_handler.ex\n│       └── test_helper.exs\n├── .tool-versions -> .harness/.tool-versions\n├── README.md\n├── config\n│   ├── config.exs\n│   ├── dev.exs\n│   ├── prod.exs\n│   └── test.exs\n├── coveralls.json -> .harness/coveralls.json\n├── harness.exs\n├── lib\n│   ├── access_token_controller.ex\n│   ├── access_token_fetcher.ex\n│   └── access_token_verifier.ex\n├── mix.exs -> .harness/mix.exs\n├── mix.lock\n└── test\n    ├── access_token_controller_test.exs\n    ├── support\n    │   └── mocks.ex\n    └── test_helper.exs -> ../.harness/test/test_helper.exs\n\n21 directories, 48 files\n```\n\nGenerally the workflow for a run of `mix harness` is\n\n1. read the configuration in `harness.exs`\n1. determine a data structure that satisfies the configuration\n1. run that configuration through template generators\n1. store the generated files in `.harness/`\n1. create any necessary symlinks from `.harness/` to `./`","ref":"gettingstarted.html#example-a-micro-controller","title":"Example: a micro controller - Getting Started","type":"extras"},{"doc":"# Manifests\n\nTL;DR: `harness.exs` describes how a harness project should be rendered.\n\nWhat's a manifest anyways? A manifest typically describes a _plan_. A `mix.exs`\nis a kind of manifest. It describes which dependencies a project relies on,\nhow it should be compiled, configured, tested, documented, and published.\nNotice, though, what a `mix.exs` _doesn't_ describe:\n\n- an exact list of files to compile, test, or document\n- an exact specification on dependency versions\n\nFor that information, you might have other more specific manifests or\n_lockfiles_: files which lock exact information into place.","ref":"manifests.html","title":"Manifests","type":"extras"},{"doc":"The harness manifest API piggy-backs off the elixir 1.9+ [Config\nAPI](https://hexdocs.pm/elixir/master/Config.html).\n\nA minimal `harness.exs` looks like so:\n\n```elixir\nimport Config\n\nconfig :harness,\n  manifest_version: \"2.0.0\",\n  generators: [],\n  deps: []\n```","ref":"manifests.html#manifest-configuration","title":"Manifest Configuration - Manifests","type":"extras"}]}